// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/MarkerCostReader.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.linkoln;


@SuppressWarnings("fallthrough")
class MarkerCostReader extends LinkolnAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int lkn = 2;
  public static final int inSection = 4;
  public static final int inAllegato = 6;
  public static final int inHp = 8;
  public static final int inMassima = 10;
  public static final int inTitoloMassima = 12;
  public static final int inTestoMassima = 14;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2,  2,  3,  3,  4,  4,  5,  5,  6,  6,  7, 7
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\37\u0200\1\u0300\u10de\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\57\0\1\1\12\0\1\2\1\0\1\3\1\0\1\4"+
    "\2\0\1\5\1\0\1\6\1\0\1\7\1\10\1\11"+
    "\1\12\1\13\1\0\1\14\1\15\1\16\1\17\1\20"+
    "\1\21\1\0\1\22\1\23\1\24\5\0\1\25\6\0"+
    "\1\5\1\0\1\6\1\0\1\7\1\10\1\11\1\12"+
    "\1\13\1\0\1\14\1\15\1\16\1\17\1\20\1\21"+
    "\1\0\1\22\1\23\1\24\5\0\1\25\265\0\2\13"+
    "\115\0\1\23\u01aa\0\1\14\325\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1024];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\10\0\2\1\1\2\3\3\2\4\1\3\2\4\45\0"+
    "\1\5\1\0\1\6\12\0\1\7\54\0\1\10\31\0"+
    "\1\11\1\12\1\13\3\0\1\14\10\0\1\15\1\0"+
    "\1\16";

  private static int [] zzUnpackAction() {
    int [] result = new int[158];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\26\0\54\0\102\0\130\0\156\0\204\0\232"+
    "\0\260\0\306\0\260\0\260\0\334\0\362\0\260\0\u0108"+
    "\0\u011e\0\u0134\0\u014a\0\u0160\0\u0176\0\u018c\0\u01a2\0\u01b8"+
    "\0\u01ce\0\u01e4\0\u01fa\0\u0210\0\u0226\0\u023c\0\u0252\0\u0268"+
    "\0\u027e\0\u0294\0\u02aa\0\u02c0\0\u02d6\0\u02ec\0\u0302\0\u0318"+
    "\0\u032e\0\u0344\0\u035a\0\u0370\0\u0386\0\u039c\0\u03b2\0\u03c8"+
    "\0\u03de\0\u03f4\0\u040a\0\u0420\0\u0436\0\u044c\0\u0462\0\u0478"+
    "\0\260\0\u048e\0\260\0\u04a4\0\u04ba\0\u04d0\0\u04e6\0\u04fc"+
    "\0\u0512\0\u0528\0\u053e\0\u0554\0\u056a\0\260\0\u0580\0\u0596"+
    "\0\u05ac\0\u05c2\0\u05d8\0\u05ee\0\u0604\0\u061a\0\u0630\0\u0646"+
    "\0\u065c\0\u0672\0\u0688\0\u069e\0\u06b4\0\u06ca\0\u06e0\0\u06f6"+
    "\0\u070c\0\u0722\0\u0738\0\u074e\0\u0764\0\u077a\0\u0790\0\u07a6"+
    "\0\u07bc\0\u07d2\0\u07e8\0\u07fe\0\u0814\0\u082a\0\u0840\0\u0856"+
    "\0\u086c\0\u0882\0\u0898\0\u08ae\0\u08c4\0\u08da\0\u08f0\0\u0906"+
    "\0\u091c\0\u0932\0\260\0\u0948\0\u095e\0\u0974\0\u098a\0\u09a0"+
    "\0\u09b6\0\u09cc\0\u09e2\0\u09f8\0\u0a0e\0\u0a24\0\u0a3a\0\u0a50"+
    "\0\u0a66\0\u0a7c\0\u0a92\0\u0aa8\0\u0abe\0\u0ad4\0\u0aea\0\u0b00"+
    "\0\u0b16\0\u0b2c\0\u0b42\0\u0b58\0\260\0\260\0\260\0\u0b6e"+
    "\0\u0b84\0\u0b9a\0\260\0\u0bb0\0\u0bc6\0\u0bdc\0\u0bf2\0\u0c08"+
    "\0\u0c1e\0\u0c34\0\u0c4a\0\260\0\u0c60\0\260";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[158];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\3\11\1\12\22\11\26\13\3\14\1\15\25\14\1\16"+
    "\22\14\3\17\1\20\22\17\3\14\1\21\22\14\3\17"+
    "\1\22\25\17\1\23\22\17\27\0\1\24\14\0\1\25"+
    "\10\0\1\26\10\0\1\27\14\0\1\30\10\0\1\31"+
    "\14\0\1\32\25\0\1\33\14\0\1\34\10\0\1\35"+
    "\25\0\1\36\42\0\1\37\31\0\1\40\21\0\1\41"+
    "\11\0\1\42\41\0\1\43\11\0\1\44\35\0\1\45"+
    "\31\0\1\46\31\0\1\47\21\0\1\50\25\0\1\51"+
    "\31\0\1\52\17\0\1\53\33\0\1\54\24\0\1\55"+
    "\26\0\1\56\24\0\1\57\6\0\1\60\45\0\1\61"+
    "\17\0\1\62\33\0\1\63\25\0\1\64\17\0\1\65"+
    "\13\0\1\66\3\0\1\67\33\0\1\70\11\0\4\55"+
    "\1\71\21\55\14\0\1\72\11\0\4\57\1\73\21\57"+
    "\21\0\1\74\20\0\1\75\17\0\1\76\33\0\1\77"+
    "\25\0\1\100\13\0\1\101\30\0\1\102\22\0\1\103"+
    "\31\0\1\104\21\0\1\105\27\0\1\106\27\0\1\107"+
    "\21\0\1\110\31\0\1\111\25\0\1\112\32\0\1\113"+
    "\27\0\1\114\26\0\1\115\4\0\1\116\4\0\1\117"+
    "\30\0\1\120\22\0\1\121\47\0\1\122\3\0\1\123"+
    "\25\0\1\124\42\0\1\125\23\0\1\126\15\0\1\127"+
    "\27\0\1\130\41\0\1\131\17\0\1\132\26\0\1\133"+
    "\16\0\1\134\42\0\1\135\25\0\1\136\11\0\1\137"+
    "\24\0\1\140\41\0\1\141\27\0\1\142\7\0\1\143"+
    "\33\0\1\144\15\0\1\145\43\0\1\146\15\0\1\147"+
    "\21\0\1\150\36\0\1\151\16\0\1\152\37\0\1\153"+
    "\15\0\1\154\37\0\1\155\7\0\1\156\41\0\1\157"+
    "\26\0\1\160\25\0\1\161\24\0\1\162\6\0\1\163"+
    "\26\0\1\164\33\0\1\165\32\0\1\166\20\0\1\167"+
    "\23\0\1\170\37\0\1\171\22\0\1\172\25\0\1\173"+
    "\31\0\1\174\25\0\1\175\17\0\1\176\26\0\1\177"+
    "\26\0\1\200\12\0\1\201\33\0\1\202\30\0\1\203"+
    "\24\0\1\174\30\0\1\204\25\0\1\205\12\0\1\206"+
    "\27\0\1\207\35\0\1\210\32\0\1\211\17\0\1\212"+
    "\14\0\1\213\36\0\1\214\13\0\1\215\21\0\4\206"+
    "\1\216\21\206\4\207\1\217\21\207\7\0\1\220\36\0"+
    "\1\220\12\0\1\220\43\0\1\221\7\0\1\222\24\0"+
    "\1\223\44\0\1\224\25\0\1\225\15\0\1\226\35\0"+
    "\1\227\20\0\1\230\22\0\1\231\17\0\1\232\36\0"+
    "\1\233\13\0\1\234\26\0\1\235\24\0\1\236\21\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[3190];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\10\0\1\11\1\1\2\11\2\1\1\11\4\1\45\0"+
    "\1\11\1\0\1\11\12\0\1\11\54\0\1\11\31\0"+
    "\3\11\3\0\1\11\10\0\1\11\1\0\1\11";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[158];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
		
	MarkerCostReader() { }
	
	private StringBuilder buffer = new StringBuilder();
	
	int previous = 0;

	private void runLinkoln() {
		
		getLinkolnDocument().costCurrentText = Util.normalizeSpaces(Util.removeAllAnnotations(buffer.toString()));
		
		//System.out.println("\n\nRUNNING ON TEXT: " + buffer.toString());
		
		Pipeline.run(getLinkolnDocument(), buffer.toString(), position);
		addText(getLinkolnDocument().getAnnotatedText());
		position += Util.removeAllAnnotations(buffer.toString()).length();
		buffer = new StringBuilder();
	}



  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  MarkerCostReader(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return YYEOF;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { addText();
	position++;
            }
          // fall through
          case 15: break;
          case 2:
            { System.out.print(yytext());
            }
          // fall through
          case 16: break;
          case 3:
            { addText();
            }
          // fall through
          case 17: break;
          case 4:
            { buffer.append(yytext());
            }
          // fall through
          case 18: break;
          case 5:
            { //READ ID ATTRIBUTE
		
		//System.out.println("IN HP " + yytext());
		
		getLinkolnDocument().costCurrentId = "";
		
		String id = "";
		
		int cut = yytext().indexOf("id");
		
		if(cut > 1) {
			
			id = yytext().substring(cut + 4);
			id = id.substring(0, id.indexOf("\""));
			
			if( !getLinkolnDocument().getSourceName().equals("")) {
			
				id = getLinkolnDocument().getSourceName() + "_" + id;
			}
			
			getLinkolnDocument().costCurrentId = id;
		}
		
		addText();
			
		yybegin(inHp);
            }
          // fall through
          case 19: break;
          case 6:
            { String id = "";
		
		int cut = yytext().indexOf("id");
		
		if(cut > 1) {
			
			id = yytext().substring(cut + 4);
			id = id.substring(0, id.indexOf("\""));
			
			if( !getLinkolnDocument().getSourceName().equals("")) {
			
				id = getLinkolnDocument().getSourceName() + "_" + id;
			}
			
			getLinkolnDocument().costCurrentId = id;
		}
		
		addText();
			
		yybegin(inHp);
            }
          // fall through
          case 20: break;
          case 7:
            { runLinkoln();
		
		addText();
		
		yybegin(previous);
            }
          // fall through
          case 21: break;
          case 8:
            { addText(yytext() + "<mrk:info>" + Linkoln.getInfo() + "</mrk:info>");
            }
          // fall through
          case 22: break;
          case 9:
            { previous = inAllegato;
	
	addText();
	
	//System.out.println("IN ALLEGATO " + yytext());
	
	yybegin(inAllegato);
            }
          // fall through
          case 23: break;
          case 10:
            { String id = "";
	
	int cut = yytext().indexOf("id");
	
	if(cut > 1) {
		
		id = yytext().substring(cut + 4);
		id = id.substring(0, id.indexOf("\""));
		
		if( !getLinkolnDocument().getSourceName().equals("")) {
		
			id = getLinkolnDocument().getSourceName() + "_" + id;
		}
		
		getLinkolnDocument().costCurrentId = id;
	}

	addText();
	
	//System.out.println("IN MASSIMA " + yytext());
	
	yybegin(inMassima);
            }
          // fall through
          case 24: break;
          case 11:
            { addText();
	
	previous = inSection;
	
	//System.out.println("IN SECTION " + yytext());
	
	yybegin(inSection);
            }
          // fall through
          case 25: break;
          case 12:
            { addText(); yybegin(0);
            }
          // fall through
          case 26: break;
          case 13:
            { addText();
			
		yybegin(inTestoMassima);
            }
          // fall through
          case 27: break;
          case 14:
            { runLinkoln();
		
		addText();
		
		yybegin(inMassima);
            }
          // fall through
          case 28: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java MarkerCostReader [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        MarkerCostReader scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new MarkerCostReader(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
